Index: trunk/NEMO/OPA_SRC/TRA/tranxt.F90
===================================================================
--- trunk/NEMO/OPA_SRC/TRA/tranxt.F90	(revision 485)
+++ trunk/NEMO/OPA_SRC/TRA/tranxt.F90	(revision 503)
@@ -4,17 +4,18 @@
    !! Ocean active tracers:  time stepping on temperature and salinity
    !!======================================================================
-   !! History :
-   !!   7.0  !  91-11  (G. Madec)  Original code
-   !!        !  93-03  (M. Guyon)  symetrical conditions
-   !!        !  96-02  (G. Madec & M. Imbard)  opa release 8.0
-   !!   8.0  !  96-04  (A. Weaver)  Euler forward step
-   !!   8.2  !  99-02  (G. Madec, N. Grima)  semi-implicit pressure grad.
-   !!   8.5  !  02-08  (G. Madec)  F90: Free form and module
-   !!        !  02-11  (C. Talandier, A-M Treguier) Open boundaries
-   !!   9.0  !  06-02  (L. Debreu, C. Mazauric) Agrif implementation
+   !! History :  7.0  !  91-11  (G. Madec)  Original code
+   !!                 !  93-03  (M. Guyon)  symetrical conditions
+   !!                 !  96-02  (G. Madec & M. Imbard)  opa release 8.0
+   !!            8.0  !  96-04  (A. Weaver)  Euler forward step
+   !!            8.2  !  99-02  (G. Madec, N. Grima)  semi-implicit pressure grad.
+   !!            8.5  !  02-08  (G. Madec)  F90: Free form and module
+   !!                 !  02-11  (C. Talandier, A-M Treguier) Open boundaries
+   !!                 !  05-04  (C. Deltel) Add Asselin trend in the ML budget
+   !!            9.0  !  06-02  (L. Debreu, C. Mazauric) Agrif implementation
+   !!----------------------------------------------------------------------
+
    !!----------------------------------------------------------------------
    !!   tra_nxt     : time stepping on temperature and salinity
    !!----------------------------------------------------------------------
-   !! * Modules used
    USE oce             ! ocean dynamics and tracers variables
    USE dom_oce         ! ocean space and time domain variables 
@@ -23,4 +24,6 @@
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
    USE obctra          ! open boundary condition (obc_tra routine)
+   USE trdmod          ! ocean active tracers trends 
+   USE trdmod_oce      ! ocean variables trends
    USE prtctl          ! Print control
    USE agrif_opa_update
@@ -31,9 +34,9 @@
 
    !! * Routine accessibility
-   PUBLIC tra_nxt          ! routine called by step.F90
-   !!----------------------------------------------------------------------
-   !!   OPA 9.0 , LOCEAN-IPSL (2005) 
+   PUBLIC   tra_nxt   ! routine called by step.F90
+   !!----------------------------------------------------------------------
+   !!   OPA 9.0 , LOCEAN-IPSL (2006) 
    !! $Header$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -67,16 +70,19 @@
       !! ** Action  : - update (tb,sb) and (tn,sn) 
       !!              - (ta,sa) time averaged (t,s)      (ln_dynhpg_imp = T)
-      !!
       !!----------------------------------------------------------------------
-      !! * Arguments
-      INTEGER, INTENT( in ) ::   kt         ! ocean time-step index
-
-      !! * Local declarations
-      INTEGER ::   ji, jj, jk   ! dummy loop indices
-      REAL(wp) ::   zt, zs      ! temporary scalars
-      REAL(wp) ::   zfact       ! temporary scalar
+      USE oce, ONLY :    ztrdt => ua   ! use ua as 3D workspace   
+      USE oce, ONLY :    ztrds => va   ! use va as 3D workspace   
+      !!
+      INTEGER, INTENT(in) ::   kt    ! ocean time-step index
+      !!
+      INTEGER  ::   ji, jj, jk   ! dummy loop indices
+      REAL(wp) ::   zt, zs       ! temporary scalars
+      REAL(wp) ::   zfact        ! temporary scalar
       !!----------------------------------------------------------------------
 
-
+      IF( l_trdtra ) THEN
+         ztrdt(:,:,jpk) = 0.e0
+         ztrds(:,:,jpk) = 0.e0
+      ENDIF
       ! 0. Lateral boundary conditions on ( ta, sa )   (T-point, unchanged sign)
       ! ---------------------------------============
@@ -84,5 +90,4 @@
       CALL lbc_lnk( sa, 'T', 1. )
 
-
       !                                                ! ===============
       DO jk = 1, jpkm1                                 ! Horizontal slab
@@ -93,7 +98,8 @@
          IF( ln_zdfexp ) THEN
             zfact = 2. * rdttra(jk)
-            IF( neuler == 0 .AND. kt == nit000 ) zfact = rdttra(jk)
+            IF( neuler == 0 .AND. kt == nit000 )   zfact = rdttra(jk)
             ta(:,:,jk) = ( tb(:,:,jk) + zfact * ta(:,:,jk) ) * tmask(:,:,jk)
             sa(:,:,jk) = ( sb(:,:,jk) + zfact * sa(:,:,jk) ) * tmask(:,:,jk)
+            IF(l_trdtra)   CALL ctl_stop( 'tranxt: Asselin ML trend not yet accounted for.' )
          ENDIF
 
@@ -102,8 +108,6 @@
       END DO                                           !   End of slab
       !                                                ! ===============
-
       ! Update tracers on open boundaries.
       CALL obc_tra( kt )
-
       !                                                ! ===============
       DO jk = 1, jpkm1                                 ! Horizontal slab
@@ -114,14 +118,10 @@
       END DO                                           !   End of slab
       !                                                ! ===============
-
       ! Update tracers on open boundaries.
       CALL Agrif_tra( kt )
-
       !                                                ! ===============
       DO jk = 1, jpkm1                                 ! Horizontal slab
          !                                             ! ===============
 #endif
-
-
          ! 2. Time filter and swap of arrays
          ! ---------------------------------
@@ -141,4 +141,8 @@
                   END DO
                END DO
+               IF( l_trdtra ) THEN
+                  ztrdt(:,:,jk) = 0.e0
+                  ztrds(:,:,jk) = 0.e0
+               END IF
             ELSE
                DO jj = 1, jpj
@@ -148,4 +152,8 @@
                      tb(ji,jj,jk) = atfp  * ( tb(ji,jj,jk) + ta(ji,jj,jk) ) + atfp1 * tn(ji,jj,jk)
                      sb(ji,jj,jk) = atfp  * ( sb(ji,jj,jk) + sa(ji,jj,jk) ) + atfp1 * sn(ji,jj,jk)
+                     IF( l_trdtra ) THEN ! ChD ceci est a optimiser, mais ca marche
+                        ztrdt(ji,jj,jk) = tb(ji,jj,jk) - tn(ji,jj,jk)
+                        ztrds(ji,jj,jk) = sb(ji,jj,jk) - sn(ji,jj,jk)
+                     END IF
                      tn(ji,jj,jk) = ta(ji,jj,jk)
                      sn(ji,jj,jk) = sa(ji,jj,jk)
@@ -165,5 +173,17 @@
                   END DO
                END DO
+               IF( l_trdtra ) THEN
+                  ztrdt(:,:,jk) = 0.e0
+                  ztrds(:,:,jk) = 0.e0
+               END IF
             ELSE
+               IF( l_trdtra ) THEN
+                  DO jj = 1, jpj
+                     DO ji = 1, jpi
+                        ztrdt(ji,jj,jk) = atfp * ( tb(ji,jj,jk) - 2*tn(ji,jj,jk) + ta(ji,jj,jk) )
+                        ztrds(ji,jj,jk) = atfp * ( sb(ji,jj,jk) - 2*sn(ji,jj,jk) + sa(ji,jj,jk) )
+                     END DO
+                  END DO
+               END IF
                DO jj = 1, jpj
                   DO ji = 1, jpi
@@ -180,13 +200,16 @@
       !                                                ! ===============
 
-      IF(ln_ctl) THEN         ! print mean field (used for debugging)
-         CALL prt_ctl(tab3d_1=tn, clinfo1=' nxt  - Tn: ', mask1=tmask, &
-            &         tab3d_2=sn, clinfo2=' Sn: ', mask2=tmask)
-      ENDIF
-      
+      IF( l_trdtra )   THEN      ! Take the Asselin trend into account 
+         ztrdt(:,:,:) = ztrdt(:,:,:) / ( 2.*rdt )
+         ztrds(:,:,:) = ztrds(:,:,:) / ( 2.*rdt )         
+         CALL trd_mod( ztrdt, ztrds, jptra_trd_atf, 'TRA', kt )
+      END IF
+
+      IF(ln_ctl)   CALL prt_ctl( tab3d_1=tn, clinfo1=' nxt  - Tn: ', mask1=tmask,   &
+         &                       tab3d_2=sn, clinfo2=       ' Sn: ', mask2=tmask )
 #if defined key_agrif
       IF (.NOT.Agrif_Root())    CALL Agrif_Update_Tra( kt )
 #endif      
-
+      !
    END SUBROUTINE tra_nxt
 
Index: trunk/NEMO/OPA_SRC/TRA/traqsr.F90
===================================================================
--- trunk/NEMO/OPA_SRC/TRA/traqsr.F90	(revision 485)
+++ trunk/NEMO/OPA_SRC/TRA/traqsr.F90	(revision 503)
@@ -4,16 +4,15 @@
    !! Ocean physics: solar radiation penetration in the top ocean levels
    !!======================================================================
-   !! History :
-   !!   6.0  !  90-10  (B. Blanke)  Original code
-   !!   7.0  !  91-11  (G. Madec)
-   !!        !  96-01  (G. Madec)  s-coordinates
-   !!   8.5  !  02-06  (G. Madec)  F90: Free form and module
-   !!   9.0  !  04-08  (C. Talandier) New trends organization
-   !!   9.0  !  05-11  (G. Madec) zco, zps, sco coordinate
+   !! History :  6.0  !  90-10  (B. Blanke)  Original code
+   !!            7.0  !  91-11  (G. Madec)
+   !!                 !  96-01  (G. Madec)  s-coordinates
+   !!            8.5  !  02-06  (G. Madec)  F90: Free form and module
+   !!            9.0  !  05-11  (G. Madec) zco, zps, sco coordinate
+   !!----------------------------------------------------------------------
+
    !!----------------------------------------------------------------------
    !!   tra_qsr      : trend due to the solar radiation penetration
    !!   tra_qsr_init : solar radiation penetration initialization
    !!----------------------------------------------------------------------
-   !! * Modules used
    USE oce             ! ocean dynamics and active tracers
    USE dom_oce         ! ocean space and time domain
@@ -29,25 +28,17 @@
    PRIVATE
 
-   !! * Routine accessibility
-   PUBLIC tra_qsr      ! routine called by step.F90 (ln_traqsr=T)
-   PUBLIC tra_qsr_init ! routine called by opa.F90
-
-   !! * Shared module variables
-   LOGICAL, PUBLIC ::   ln_traqsr = .TRUE.   !: qsr flag (Default=T)
-
-   !! * Module variables
-   REAL(wp), PUBLIC ::  & !!! * penetrative solar radiation namelist *
-      rabs = 0.58_wp,   &  ! fraction associated with xsi1
-      xsi1 = 0.35_wp,   &  ! first depth of extinction 
-      xsi2 = 23.0_wp       ! second depth of extinction 
-      !                    ! (default values: water type Ib)
-   LOGICAL ::           & 
-      ln_qsr_sms = .false. ! flag to use or not the biological 
-      !                    ! fluxes for light 
+   PUBLIC   tra_qsr      ! routine called by step.F90 (ln_traqsr=T)
+   PUBLIC   tra_qsr_init ! routine called by opa.F90
+
+   !!* Namelist namqsr: penetrative solar radiation
+   LOGICAL , PUBLIC ::   ln_traqsr = .TRUE.   !: qsr flag (Default=T)
+   REAL(wp), PUBLIC ::   rabs = 0.58_wp       ! fraction associated with xsi1
+   REAL(wp), PUBLIC ::   xsi1 = 0.35_wp       ! first depth of extinction 
+   REAL(wp), PUBLIC ::   xsi2 = 23.0_wp       ! second depth of extinction (default values: water type Ib)
+   LOGICAL , PUBLIC ::   ln_qsr_sms = .false. ! flag to use or not the biological fluxes for light 
+   NAMELIST/namqsr/ ln_traqsr, rabs, xsi1, xsi2, ln_qsr_sms
    
-   INTEGER ::    &
-      nksr                 ! number of levels
-   REAL(wp), DIMENSION(jpk) ::   &
-      gdsr                 ! profile of the solar flux penetration
+   INTEGER ::   nksr   ! number of levels
+   REAL(wp), DIMENSION(jpk) ::   gdsr   ! profile of the solar flux penetration
 
    !! * Substitutions
@@ -57,5 +48,5 @@
    !!   OPA 9.0 , LOCEAN-IPSL (2005) 
    !! $Header$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -86,27 +77,22 @@
       !! ** Action  : - update ta with the penetrative solar radiation trend
       !!              - save the trend in ttrd ('key_trdtra')
-      !!
-      !!----------------------------------------------------------------------
-      !! * Modules used     
-      USE oce, ONLY :    ztrdt => ua,   & ! use ua as 3D workspace   
-                         ztrds => va      ! use va as 3D workspace   
-
-      !! * Arguments
-      INTEGER, INTENT( in ) ::   kt       ! ocean time-step
-
-      !! * Local declarations
-      INTEGER ::    ji, jj, jk            ! dummy loop indexes
-      REAL(wp) ::   zc0 , zta             ! temporary scalars
+      !!----------------------------------------------------------------------
+      USE oce, ONLY :   ztrdt => ua   ! use ua as 3D workspace   
+      USE oce, ONLY :   ztrds => va   ! use va as 3D workspace   
+      !!
+      INTEGER, INTENT(in) ::   kt     ! ocean time-step
+      !!
+      INTEGER  ::    ji, jj, jk       ! dummy loop indexes
+      REAL(wp) ::   zc0 , zta         ! temporary scalars
       !!----------------------------------------------------------------------
 
       IF( kt == nit000 ) THEN
-         IF ( lwp )  WRITE(numout,*)
-         IF ( lwp )  WRITE(numout,*) 'tra_qsr : penetration of the surface solar radiation'
-         IF ( lwp )  WRITE(numout,*) '~~~~~~~'
+         IF(lwp) WRITE(numout,*)
+         IF(lwp) WRITE(numout,*) 'tra_qsr : penetration of the surface solar radiation'
+         IF(lwp) WRITE(numout,*) '~~~~~~~'
          CALL tra_qsr_init
       ENDIF
 
-      ! Save ta and sa trends
-      IF( l_trdtra )   THEN
+      IF( l_trdtra ) THEN      ! Save ta and sa trends
          ztrdt(:,:,:) = ta(:,:,:) 
          ztrds(:,:,:) = 0.e0
@@ -122,11 +108,8 @@
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1   ! vector opt.
-                  
                   zc0 = ro0cpr  / fse3t(ji,jj,jk)         ! compute the qsr trend
                   zta = zc0 * ( etot3(ji,jj,jk  ) * tmask(ji,jj,jk)     &
                      &        - etot3(ji,jj,jk+1) * tmask(ji,jj,jk+1) )
-                  
                   ta(ji,jj,jk) = ta(ji,jj,jk) + zta       ! add qsr trend to the temperature trend
-                  
                END DO
             END DO
@@ -179,13 +162,11 @@
       ENDIF
 
-      ! qsr tracers trends saved the trends for diagnostics
-      IF( l_trdtra )   THEN
+      IF( l_trdtra ) THEN     ! qsr tracers trends saved for diagnostics
          ztrdt(:,:,:) = ta(:,:,:) - ztrdt(:,:,:)
-         CALL trd_mod( ztrdt, ztrds, jpttdqsr, 'TRA', kt )
-      ENDIF
-
+         CALL trd_mod( ztrdt, ztrds, jptra_trd_qsr, 'TRA', kt )
+      ENDIF
       !                       ! print mean trends (used for debugging)
       IF(ln_ctl)   CALL prt_ctl( tab3d_1=ta, clinfo1=' qsr  - Ta: ', mask1=tmask, clinfo3='tra-ta' )
-
+      !
    END SUBROUTINE tra_qsr
 
@@ -206,23 +187,16 @@
       !! ** Action  : - initialize xsr1, xsr2 and rabs
       !!
-      !! Reference :
-      !!   Jerlov, N. G., 1968 Optical Oceanography, Elsevier, 194pp.
-      !!----------------------------------------------------------------------
-      INTEGER ::    ji,jj,jk, &  ! dummy loop index
-                    indic        ! temporary integer
-      REAL(wp) ::   zc0 , zc1 , zc2 ,   & ! temporary scalars
-         &          zcst, zdp1, zdp2      !    "         "
-
-      NAMELIST/namqsr/ ln_traqsr, rabs, xsi1, xsi2, ln_qsr_sms
-      !!----------------------------------------------------------------------
-
-      ! Read Namelist namqsr : ratio and length of penetration
-      ! --------------------
-      REWIND ( numnam )
+      !! Reference : Jerlov, N. G., 1968 Optical Oceanography, Elsevier, 194pp.
+      !!----------------------------------------------------------------------
+      INTEGER  ::   ji, jj, jk   ! dummy loop index
+      INTEGER  ::   indic        ! temporary integer
+      REAL(wp) ::   zc0 , zc1 , zc2    ! temporary scalars
+      REAL(wp) ::   zcst, zdp1, zdp2   !    "         "
+      !!----------------------------------------------------------------------
+
+      REWIND ( numnam )           ! Read Namelist namqsr : ratio and length of penetration
       READ   ( numnam, namqsr )
 
-      ! Parameter control and print
-      ! ---------------------------
-      IF( ln_traqsr  ) THEN
+      IF( ln_traqsr  ) THEN       ! Parameter control and print
          IF(lwp) THEN
             WRITE(numout,*)
@@ -248,8 +222,7 @@
          CALL ctl_stop( '             0<rabs<1, 0<xsi1, or 0<xsi2 not satisfied' )
 
-      ! Initialization of gdsr
-      ! ----------------------
+      !                           ! Initialization of gdsr
       IF( ln_zco .OR. ln_zps ) THEN
-
+         !
          ! z-coordinate with or without partial step : same w-level everywhere inside the ocean
          gdsr(:) = 0.e0
@@ -283,5 +256,5 @@
             END DO
          ENDIF
-
+         !
       ENDIF
 
@@ -302,6 +275,6 @@
             END DO
          END DO 
-       ENDIF
-
+      ENDIF
+      !
    END SUBROUTINE tra_qsr_init
 
Index: trunk/NEMO/OPA_SRC/TRA/trasbc.F90
===================================================================
--- trunk/NEMO/OPA_SRC/TRA/trasbc.F90	(revision 485)
+++ trunk/NEMO/OPA_SRC/TRA/trasbc.F90	(revision 503)
@@ -4,13 +4,12 @@
    !! Ocean active tracers:  surface boundary condition
    !!==============================================================================
-   !! History :
-   !!   8.2  !  98-10  (G. Madec, G. Roullet, M. Imbard)  Original code
-   !!   8.2  !  01-02  (D. Ludicone)  sea ice and free surface
-   !!   8.5  !  02-06  (G. Madec)  F90: Free form and module
-   !!   9.0  !  04-08  (C. Talandier) New trends organization
+   !! History :  8.2  !  98-10  (G. Madec, G. Roullet, M. Imbard)  Original code
+   !!            8.2  !  01-02  (D. Ludicone)  sea ice and free surface
+   !!            8.5  !  02-06  (G. Madec)  F90: Free form and module
+   !!----------------------------------------------------------------------
+
    !!----------------------------------------------------------------------
    !!   tra_sbc      : update the tracer trend at ocean surface
    !!----------------------------------------------------------------------
-   !! * Modules used
    USE oce             ! ocean dynamics and active tracers
    USE dom_oce         ! ocean space domain variables
@@ -26,6 +25,5 @@
    PRIVATE
 
-   !! * Routine accessibility
-   PUBLIC tra_sbc              ! routine called by step.F90
+   PUBLIC   tra_sbc    ! routine called by step.F90
 
    !! * Substitutions
@@ -35,5 +33,5 @@
    !!   OPA 9.0 , LOCEAN-IPSL (2005) 
    !! $Header$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -78,14 +76,10 @@
       !!                with the tracer surface boundary condition 
       !!              - save the trend it in ttrd ('key_trdtra')
+      !!----------------------------------------------------------------------
+      USE oce, ONLY :   ztrdt => ua   ! use ua as 3D workspace   
+      USE oce, ONLY :   ztrds => va   ! use va as 3D workspace   
       !!
-      !!----------------------------------------------------------------------
-      !! * Modules used     
-      USE oce, ONLY :    ztdta => ua,      & ! use ua as 3D workspace   
-                         ztdsa => va         ! use va as 3D workspace   
-
-      !! * Arguments
-      INTEGER, INTENT( in ) ::   kt          ! ocean time-step index
-
-      !! * Local declarations
+      INTEGER, INTENT(in) ::   kt     ! ocean time-step index
+      !!
       INTEGER  ::   ji, jj                   ! dummy loop indices
       REAL(wp) ::   zta, zsa, zsrau, zse3t   ! temporary scalars
@@ -98,19 +92,17 @@
       ENDIF
 
-      ! 0. initialization
-      zsrau = 1. / rauw
+      zsrau = 1. / rauw             ! initialization
 #if defined key_zco
       zse3t = 1. / e3t_0(1)
 #endif
 
-      ! Save ta and sa trends
-      IF( l_trdtra )   THEN
-         ztdta(:,:,:) = ta(:,:,:) 
-         ztdsa(:,:,:) = sa(:,:,:) 
+      IF( l_trdtra ) THEN           ! Save ta and sa trends
+         ztrdt(:,:,:) = ta(:,:,:) 
+         ztrds(:,:,:) = sa(:,:,:) 
       ENDIF
 
       IF( .NOT.ln_traqsr )   qsr(:,:) = 0.e0   ! no solar radiation penetration
 
-      ! 1. Concentration dillution effect on (t,s)
+      ! Concentration dillution effect on (t,s)
       DO jj = 2, jpj
          DO ji = fs_2, fs_jpim1   ! vector opt.
@@ -118,29 +110,20 @@
             zse3t = 1. / fse3t(ji,jj,1)
 #endif
-            ! temperature : heat flux
-            zta = ro0cpr * ( qt(ji,jj) - qsr(ji,jj) ) * zse3t
-
-            ! salinity :  concent./dilut. effect
-            zsa = emps(ji,jj) * zsrau * sn(ji,jj,1) * zse3t
-            
-            ! add the trend to the general tracer trend
-            ta(ji,jj,1) = ta(ji,jj,1) + zta
+            zta = ro0cpr * ( qt(ji,jj) - qsr(ji,jj) ) * zse3t      ! temperature : heat flux
+            zsa = emps(ji,jj) * zsrau * sn(ji,jj,1)   * zse3t      ! salinity :  concent./dilut. effect
+            ta(ji,jj,1) = ta(ji,jj,1) + zta                        ! add the trend to the general tracer trend
             sa(ji,jj,1) = sa(ji,jj,1) + zsa
          END DO
       END DO
 
-      ! save the trends for diagnostic
-      ! sea surface boundary condition tracers trends
-      IF( l_trdtra )   THEN
-         ztdta(:,:,:) = ta(:,:,:) - ztdta(:,:,:)
-         ztdsa(:,:,:) = sa(:,:,:) - ztdsa(:,:,:)
-         CALL trd_mod(ztdta, ztdsa, jpttdnsr, 'TRA', kt)
+      IF( l_trdtra ) THEN      ! save the sbc trends for diagnostic
+         ztrdt(:,:,:) = ta(:,:,:) - ztrdt(:,:,:)
+         ztrds(:,:,:) = sa(:,:,:) - ztrds(:,:,:)
+         CALL trd_mod(ztrdt, ztrds, jptra_trd_nsr, 'TRA', kt)
       ENDIF
-      
-      IF(ln_ctl) THEN         ! print mean trends (used for debugging)
-         CALL prt_ctl(tab3d_1=ta, clinfo1=' sbc  - Ta: ', mask1=tmask, &
-            &         tab3d_2=sa, clinfo2=' Sa: ', mask2=tmask, clinfo3='tra')
-      ENDIF
-
+      !
+      IF(ln_ctl)   CALL prt_ctl( tab3d_1=ta, clinfo1=' sbc  - Ta: ', mask1=tmask,   &
+         &                       tab3d_2=sa, clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
+      !
    END SUBROUTINE tra_sbc
 
Index: trunk/NEMO/OPA_SRC/TRA/trazdf.F90
===================================================================
--- trunk/NEMO/OPA_SRC/TRA/trazdf.F90	(revision 485)
+++ trunk/NEMO/OPA_SRC/TRA/trazdf.F90	(revision 503)
@@ -4,11 +4,11 @@
    !! Ocean active tracers:  vertical component of the tracer mixing trend
    !!==============================================================================
-   !! History :
-   !!   9.0  !  05-11  (G. Madec)  Original code
+   !! History :  9.0  !  05-11  (G. Madec)  Original code
+   !!----------------------------------------------------------------------
+
    !!----------------------------------------------------------------------
    !!   tra_zdf      : Update the tracer trend with the vertical diffusion
    !!       zdf_ctl  : ???
    !!----------------------------------------------------------------------
-   !! * Modules used
    USE oce             ! ocean dynamics and tracers variables
    USE dom_oce         ! ocean space and time domain variables 
@@ -28,16 +28,11 @@
    PRIVATE
 
-   !! * Routine accessibility
    PUBLIC tra_zdf   !  routine called by step.F90
 
-   !! * module variables
-   INTEGER ::                        &
-      nzdf = 0                         ! type vertical diffusion algorithm used
+   INTEGER ::   nzdf = 0               ! type vertical diffusion algorithm used
       !                                ! defined from ln_zdf...  namlist logicals)
 
-   !! * Module variables
-   REAL(wp), DIMENSION(jpk) ::  &
-      r2dt                          ! vertical profile time-step, = 2 rdttra
-      !                             ! except at nit000 (=rdttra) if neuler=0
+   REAL(wp), DIMENSION(jpk) ::   r2dt  ! vertical profile time-step, = 2 rdttra
+      !                                ! except at nit000 (=rdttra) if neuler=0
 
    !! * Substitutions
@@ -47,4 +42,6 @@
    !!----------------------------------------------------------------------
    !!  OPA 9.0 , LOCEAN-IPSL (2005) 
+   !! $Header$ 
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -56,15 +53,9 @@
       !!
       !! ** Purpose :   compute the vertical ocean tracer physics.
-      !! ** Method  :
-      !! ** Action  :
-      !!
       !!---------------------------------------------------------------------
-      !! * Arguments
       INTEGER, INTENT( in ) ::   kt      ! ocean time-step index
 
-      !! * local declarations
       INTEGER  ::   jk                   ! Dummy loop indices
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   &
-         ztrdt, ztrds                         ! 3D temporary workspace
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   ztrdt, ztrds   ! 3D workspace
       !!---------------------------------------------------------------------
 
@@ -77,5 +68,4 @@
          r2dt(:) = 2. * rdttra(:)                      ! = 2 rdttra (leapfrog)
       ENDIF
-
 
       IF( l_trdtra )   THEN                      ! temporary save of ta and sa trends
@@ -101,5 +91,5 @@
             ztrdt(:,:,:) = ta(:,:,:) - ztrdt(:,:,:)
             ztrds(:,:,:) = sa(:,:,:) - ztrds(:,:,:)
-            CALL trd_mod( ztrdt, ztrds, jpttdzdf, 'TRA', kt )
+            CALL trd_mod( ztrdt, ztrds, jptra_trd_zdf, 'TRA', kt )
          ENDIF
 
@@ -111,5 +101,5 @@
                ztrds(:,:,jk) = ( ( sa(:,:,jk) - sb(:,:,jk) ) / r2dt(jk) ) - ztrds(:,:,jk)
             END DO
-            CALL trd_mod( ztrdt, ztrds, jpttdzdf, 'TRA', kt )
+            CALL trd_mod( ztrdt, ztrds, jptra_trd_zdf, 'TRA', kt )
          ENDIF
 
@@ -121,5 +111,5 @@
                ztrds(:,:,jk) = ( ( sa(:,:,jk) - sb(:,:,jk) ) / r2dt(jk) ) - ztrds(:,:,jk)
             END DO
-            CALL trd_mod( ztrdt, ztrds, jpttdzdf, 'TRA', kt )
+            CALL trd_mod( ztrdt, ztrds, jptra_trd_zdf, 'TRA', kt )
          ENDIF
 
@@ -146,7 +136,5 @@
       !!      NB: rotation of lateral mixing operator or TKE or KPP scheme,
       !!      the implicit scheme is required.
-      !!
       !!----------------------------------------------------------------------
-      !! * Module used
       USE zdftke
       USE zdfkpp
Index: trunk/NEMO/OPA_SRC/TRA/trazdf_imp.F90
===================================================================
--- trunk/NEMO/OPA_SRC/TRA/trazdf_imp.F90	(revision 485)
+++ trunk/NEMO/OPA_SRC/TRA/trazdf_imp.F90	(revision 503)
@@ -13,6 +13,5 @@
    !!        !  00-08 (G. Madec) double diffusive mixing
    !!   8.5  !  02-08 (G. Madec)  F90: Free form and module
-   !!   9.0  !  04-08 (C. Talandier) New trends organization
-   !!   " "  !  06-11 (G. Madec)  New step reorganisation
+   !!   9.0  !  06-11 (G. Madec)  New step reorganisation
    !!----------------------------------------------------------------------
    !!   tra_zdf_imp : Update the tracer trend with the diagonal vertical  
@@ -61,5 +60,5 @@
       !!
       !! ** Method  :   The vertical component of the lateral diffusive trends
-      !!      is provided by a 2nd order operator rotated along neural or geo-
+      !!      is provided by a 2nd order operator rotated along neutral or geo-
       !!      potential surfaces to which an eddy induced advection can be 
       !!      added. It is computed using before fields (forward in time) and 
